

#include "nanojit.h"

namespace nanojit
{

void RegAlloc::nInitHint() {
	NanoAssert(0);
}

RegisterMask RegAlloc::nRegCopyCandidates(Register r, RegisterMask allow) {
	NanoUnusedVariable(r);
	NanoUnusedVariable(allow);
	NanoAssert(0);
	return allow;
}

RegisterMask RegAlloc::nInitManagedRegisters(const Config* config) {
	NanoUnusedVariable(config);
	NanoAssert(0);
	return 0xFFFFFFFF;
}

RegisterMask RegAlloc::nHint(LIns* ins) {
	NanoUnusedVariable(ins);
	NanoAssert(0);
	return 0;
}

bool RegAlloc::nCanRemat(LIns* ins) {
	NanoUnusedVariable(ins);
	NanoAssert(0);
	return false;
}


//////////////

void Assembler::nCreate() {
	NanoAssert(0);
}

void Assembler::nDestroy() {
	NanoAssert(0);
}

void Assembler::nBeginAssembly(Allocator* compilationAllocator) {
	NanoUnusedVariable(compilationAllocator);
	NanoAssert(0);

}

void Assembler::nEndAssembly(Allocator* compilationAllocator) {
	NanoUnusedVariable(compilationAllocator);
}

void Assembler::nPatchRelativeBranch(NIns *patch, const NIns *target) {
	NanoUnusedVariable(patch);
	NanoUnusedVariable(target);
	NanoAssert(0);
}

void Assembler::nPatchRelativeOffset(const NIns *originalAddress, NIns *opcode) {
	NanoUnusedVariable(originalAddress);
	NanoUnusedVariable(opcode);
	NanoAssert(0);
}

NIns* Assembler::nEntryPoint(RegisterMask saveMask) {
	NanoUnusedVariable(saveMask);
	NanoAssert(0);
	return _nIns;
}

NIns* Assembler::nExitPoint(RegisterMask restoreMask) {
	NanoUnusedVariable(restoreMask);
	NanoAssert(0);
	return _nIns;
}

void Assembler::nPrologue() {
	NanoAssert(0);
}

void Assembler::nInsertRandomNop() {
	NanoAssert(0);
}

void Assembler::nRestore(LIns *ins, Register r) {
	NanoUnusedVariable(ins);
	NanoUnusedVariable(r);
	NanoAssert(0);
}

void Assembler::nSpill(const LIns* insToSpill) {
	NanoUnusedVariable(insToSpill);
	NanoAssert(0);
}

void Assembler::nSaveFlag(LIns* ins) {
	NanoUnusedVariable(ins);
	NanoAssert(0);
}

void Assembler::nRestoreFlag(LIns* ins) {
	NanoUnusedVariable(ins);
	NanoAssert(0);
}

void Assembler::nStoreToStack(LIns* ins, int d, RegisterMask allow) {
	NanoUnusedVariable(ins);
	NanoUnusedVariable(d);
	NanoUnusedVariable(allow);
	NanoAssert(0);
}

void Assembler::nGpCopy(Register d, Register s) {
	NanoUnusedVariable(d);
	NanoUnusedVariable(s);
	NanoAssert(0);
}

void Assembler::nNonGpCopy(Register d, Register s) {
	NanoUnusedVariable(d);
	NanoUnusedVariable(s);
	NanoAssert(0);
}

void Assembler::nLoad32(LIns *ins) {
	NanoUnusedVariable(ins);
	NanoAssert(0);
}

void Assembler::nLoad64(LIns *ins) {
	NanoUnusedVariable(ins);
	NanoAssert(0);
}

void Assembler::nStore32(LOpcode op, LIns *value, int d, LIns *base) {
	NanoUnusedVariable(op);
	NanoUnusedVariable(value);
	NanoUnusedVariable(d);
	NanoUnusedVariable(base);
	NanoAssert(0);
}

void Assembler::nStore64(LOpcode op, LIns *value, int d, LIns *base) {
	NanoUnusedVariable(op);
	NanoUnusedVariable(value);
	NanoUnusedVariable(d);
	NanoUnusedVariable(base);
	NanoAssert(0);
}

void Assembler::nImmI(LIns *ins) {
	NanoUnusedVariable(ins);
	NanoAssert(0);
}

void Assembler::nImmQ(LIns *ins) {
	NanoUnusedVariable(ins);
	NanoAssert(0);
}

void Assembler::nImmF(LIns *ins) {
	NanoUnusedVariable(ins);
	NanoAssert(0);
}

void Assembler::nImmD(LIns *ins) {
	NanoUnusedVariable(ins);
	NanoAssert(0);
}

void Assembler::nCopyI(LIns* ins) {
	NanoUnusedVariable(ins);
	NanoAssert(0);
}

void Assembler::nCopyQ(LIns* ins) {
	NanoUnusedVariable(ins);
	NanoAssert(0);
}

void Assembler::nCopyF(LIns* ins) {
	NanoUnusedVariable(ins);
	NanoAssert(0);
}

void Assembler::nCopyD(LIns* ins) {
	NanoUnusedVariable(ins);
	NanoAssert(0);
}


void Assembler::nLabel() {
	NanoAssert(0);
}

NIns* Assembler::nRelativeBranch(const NIns* target) {
	NanoUnusedVariable(target);
	NanoAssert(0);
	return NULL;
}

void Assembler::nRelativeBranchCond(bool onFalse, LIns *cond, const NIns *target, bool patchable, Branches* branches) {
	NanoUnusedVariable(onFalse);
	NanoUnusedVariable(cond);
	NanoUnusedVariable(target);
	NanoUnusedVariable(patchable);
	NanoUnusedVariable(branches);
	NanoAssert(0);
}

void Assembler::nCmov(LIns *ins) {
	NanoUnusedVariable(ins);
	NanoAssert(0);
}

void Assembler::nCall(LIns* ins, const NIns *address) {
	NanoUnusedVariable(ins);
	NanoUnusedVariable(address);
	NanoAssert(0);
}

// add addc sub subb and andc or xor mul (i and q types only)
void Assembler::nArith(LIns *ins) {
	NanoUnusedVariable(ins);
	NanoAssert(0);
}

// i and q types only
void Assembler::nNegNot(LIns* ins) {
	NanoUnusedVariable(ins);
	NanoAssert(0);
}

// add sub div mul (f, d, f4 types)
void Assembler::nFop(LIns *ins) {
	NanoUnusedVariable(ins);
	NanoAssert(0);
}

// f, d, f4 types
void Assembler::nNegAbs(LIns *ins) {
	NanoUnusedVariable(ins);
	NanoAssert(0);
}

void Assembler::nMull(LIns* ins) {
	NanoUnusedVariable(ins);
	NanoAssert(0);
}

void Assembler::nMullhi(LIns* ins) {
	NanoUnusedVariable(ins);
	NanoAssert(0);
}

void Assembler::nRecipSqrt(LIns* ins) {
	NanoUnusedVariable(ins);
	NanoAssert(0);
}


// float conversions / reinterpretations.

void Assembler::nMovI(LIns* ins) {
	NanoUnusedVariable(ins);
	NanoAssert(0);
}

void Assembler::nMovQ(LIns* ins) {
	NanoUnusedVariable(ins);
	NanoAssert(0);
}

void Assembler::nMovF(LIns* ins) {
	NanoUnusedVariable(ins);
	NanoAssert(0);
}

void Assembler::nMovD(LIns* ins) {
	NanoUnusedVariable(ins);
	NanoAssert(0);
}


void Assembler::nFconv(LIns* ins) {
	NanoUnusedVariable(ins);
	NanoAssert(0);
}

} // namespace nanojit

