
#include "ExternalCall.h"

namespace nanojit
{
namespace interpreter
{


// should probably be auto generated
void doExternalCallFromSignature(IntepreterContext* context, uintptr_t callAddress, unsigned int resultReg, CallSignature signature) {

	NanoUnusedVariable(resultReg);

	switch (signature) {

	case MAKE_CALL_SIGNATURE_0(LTy_V):
		doVoidExternalCall0(context, callAddress);
		break;

	case MAKE_CALL_SIGNATURE_1(LTy_V, LTy_I):
		doVoidExternalCall1<uint32_t>(context, callAddress);
		break;

	case MAKE_CALL_SIGNATURE_2(LTy_V, LTy_I, LTy_I):
		doVoidExternalCall2<uint32_t, uint32_t>(context, callAddress);
		break;

	case MAKE_CALL_SIGNATURE_3(LTy_V, LTy_I, LTy_I, LTy_I):
		doVoidExternalCall3<uint32_t, uint32_t, uint32_t>(context, callAddress);
		break;

	case MAKE_CALL_SIGNATURE_4(LTy_V, LTy_I, LTy_I, LTy_I, LTy_I):
		doVoidExternalCall4<uint32_t, uint32_t, uint32_t, uint32_t>(context, callAddress);
		break;

	case MAKE_CALL_SIGNATURE_5(LTy_V, LTy_I, LTy_I, LTy_I, LTy_I, LTy_I):
		doVoidExternalCall5<uint32_t, uint32_t, uint32_t, uint32_t, uint32_t>(context, callAddress);
		break;

	case MAKE_CALL_SIGNATURE_6(LTy_V, LTy_I, LTy_I, LTy_I, LTy_I, LTy_I, LTy_I):
		doVoidExternalCall6<uint32_t, uint32_t, uint32_t, uint32_t, uint32_t, uint32_t>(context, callAddress);
		break;

	case MAKE_CALL_SIGNATURE_7(LTy_V, LTy_I, LTy_I, LTy_I, LTy_I, LTy_I, LTy_I, LTy_I):
		doVoidExternalCall7<uint32_t, uint32_t, uint32_t, uint32_t, uint32_t, uint32_t, uint32_t>(context, callAddress);
		break;

	case MAKE_CALL_SIGNATURE_8(LTy_V, LTy_I, LTy_I, LTy_I, LTy_I, LTy_I, LTy_I, LTy_I, LTy_I):
		doVoidExternalCall8<uint32_t, uint32_t, uint32_t, uint32_t, uint32_t, uint32_t, uint32_t, uint32_t>(context, callAddress);
		break;

	//
	case MAKE_CALL_SIGNATURE_0(LTy_I):
		doExternalCall0<uint32_t>(context, callAddress, resultReg);
		break;

	case MAKE_CALL_SIGNATURE_1(LTy_I, LTy_I):
		doExternalCall1<uint32_t, uint32_t>(context, callAddress, resultReg);
		break;

	case MAKE_CALL_SIGNATURE_2(LTy_I, LTy_I, LTy_I):
		doExternalCall2<uint32_t, uint32_t, uint32_t>(context, callAddress, resultReg);
		break;

	case MAKE_CALL_SIGNATURE_3(LTy_I, LTy_I, LTy_I, LTy_I):
		doExternalCall3<uint32_t, uint32_t, uint32_t, uint32_t>(context, callAddress, resultReg);
		break;

	case MAKE_CALL_SIGNATURE_4(LTy_I, LTy_I, LTy_I, LTy_I, LTy_I):
		doExternalCall4<uint32_t, uint32_t, uint32_t, uint32_t, uint32_t>(context, callAddress, resultReg);
		break;

	case MAKE_CALL_SIGNATURE_5(LTy_I, LTy_I, LTy_I, LTy_I, LTy_I, LTy_I):
		doExternalCall5<uint32_t, uint32_t, uint32_t, uint32_t, uint32_t, uint32_t>(context, callAddress, resultReg);
		break;

	case MAKE_CALL_SIGNATURE_6(LTy_I, LTy_I, LTy_I, LTy_I, LTy_I, LTy_I, LTy_I):
		doExternalCall6<uint32_t, uint32_t, uint32_t, uint32_t, uint32_t, uint32_t, uint32_t>(context, callAddress, resultReg);
		break;

	case MAKE_CALL_SIGNATURE_7(LTy_I, LTy_I, LTy_I, LTy_I, LTy_I, LTy_I, LTy_I, LTy_I):
		doExternalCall7<uint32_t, uint32_t, uint32_t, uint32_t, uint32_t, uint32_t, uint32_t, uint32_t>(context, callAddress, resultReg);
		break;

	case MAKE_CALL_SIGNATURE_8(LTy_I, LTy_I, LTy_I, LTy_I, LTy_I, LTy_I, LTy_I, LTy_I, LTy_I):
		doExternalCall8<uint32_t, uint32_t, uint32_t, uint32_t, uint32_t, uint32_t, uint32_t, uint32_t, uint32_t>(context, callAddress, resultReg);
		break;

#if defined(NANOJIT_64BIT)

	// 
	case MAKE_CALL_SIGNATURE_1(LTy_I, LTy_Q):
		doExternalCall1<uint32_t, uint64_t>(context, callAddress, resultReg);
		break;

	//
	case MAKE_CALL_SIGNATURE_1(LTy_V, LTy_Q):
		doVoidExternalCall1<uint64_t>(context, callAddress);
		break;

	case MAKE_CALL_SIGNATURE_2(LTy_V, LTy_Q, LTy_I):
		doVoidExternalCall2<uint64_t, uint32_t>(context, callAddress);
		break;

	case MAKE_CALL_SIGNATURE_3(LTy_V, LTy_Q, LTy_I, LTy_I):
		doVoidExternalCall3<uint64_t, uint32_t, uint32_t>(context, callAddress);
		break;

	case MAKE_CALL_SIGNATURE_7(LTy_V, LTy_Q, LTy_I, LTy_I, LTy_I, LTy_I, LTy_I, LTy_I):
		doVoidExternalCall7<uint64_t, uint32_t, uint32_t, uint32_t, uint32_t, uint32_t, uint32_t>(context, callAddress);
		break;

	//
	case MAKE_CALL_SIGNATURE_1(LTy_Q, LTy_I):
		doExternalCall1<uint64_t, uint32_t>(context, callAddress, resultReg);
		break;

	//
	case MAKE_CALL_SIGNATURE_4(LTy_Q, LTy_Q, LTy_I, LTy_I, LTy_I):
		doExternalCall4<uint64_t, uint64_t, uint32_t, uint32_t, uint32_t>(context, callAddress, resultReg);
		break;

	//
	case MAKE_CALL_SIGNATURE_2(LTy_I, LTy_Q, LTy_I):
		doExternalCall2<uint32_t, uint64_t, uint32_t>(context, callAddress, resultReg);
		break;

	case MAKE_CALL_SIGNATURE_6(LTy_I, LTy_Q, LTy_I, LTy_I, LTy_I, LTy_I, LTy_I):
		doExternalCall6<uint32_t, uint64_t, uint32_t, uint32_t, uint32_t, uint32_t, uint32_t>(context, callAddress, resultReg);
		break;

		//
	case MAKE_CALL_SIGNATURE_4(LTy_V, LTy_I, LTy_I, LTy_I, LTy_Q):
		doVoidExternalCall4<uint32_t, uint32_t, uint32_t, uint64_t>(context, callAddress);
		break;

	case MAKE_CALL_SIGNATURE_5(LTy_V, LTy_I, LTy_I, LTy_I, LTy_I, LTy_Q):
		doVoidExternalCall5<uint32_t, uint32_t, uint32_t, uint32_t, uint64_t>(context, callAddress);
		break;

	case MAKE_CALL_SIGNATURE_4(LTy_I, LTy_Q, LTy_I, LTy_I, LTy_I):
		doExternalCall4<uint32_t, uint64_t, uint32_t, uint32_t, uint32_t>(context, callAddress, resultReg);
		break;

#endif // defined(NANOJIT_64BIT)

	default:
		NanoAssert(0); // unsupported signature
		break;

	}
}

} // namespace interpreter
} // namespace nanojit
