

#include <NativeInterpreterTypes.h>

#define MAKE_CALL_SIGNATURE_0(retType) \
	(CallSignature)((retType + 1))

#define MAKE_CALL_SIGNATURE_1(retType, param0Type)	\
	(	(CallSignature)(((retType) + 1))				\
	|	((CallSignature)(((param0Type) + 1)) << 3))	

#define MAKE_CALL_SIGNATURE_2(retType, param0Type, param1Type) \
	(	(CallSignature)(((retType) + 1))				\
	|	((CallSignature)(((param0Type) + 1)) << 3)		\
	|	((CallSignature)(((param1Type) + 1)) << 6))

#define MAKE_CALL_SIGNATURE_3(retType, param0Type, param1Type, param2Type) \
	(	(CallSignature)(((retType) + 1))				\
	|	((CallSignature)(((param0Type) + 1)) << 3)		\
	|	((CallSignature)(((param1Type) + 1)) << 6)		\
	|	((CallSignature)(((param2Type) + 1)) << 9))

#define MAKE_CALL_SIGNATURE_4(retType, param0Type, param1Type, param2Type, param3Type) \
	(	(CallSignature)(((retType) + 1))				\
	|	((CallSignature)(((param0Type) + 1)) << 3)		\
	|	((CallSignature)(((param1Type) + 1)) << 6)		\
	|	((CallSignature)(((param2Type) + 1)) << 9)		\
	|	((CallSignature)(((param3Type) + 1)) << 12))

#define MAKE_CALL_SIGNATURE_5(retType, param0Type, param1Type, param2Type, param3Type, param4Type) \
	(	(CallSignature)(((retType) + 1))				\
	|	((CallSignature)(((param0Type) + 1)) << 3)		\
	|	((CallSignature)(((param1Type) + 1)) << 6)		\
	|	((CallSignature)(((param2Type) + 1)) << 9)		\
	|	((CallSignature)(((param3Type) + 1)) << 12)		\
	|	((CallSignature)(((param4Type) + 1)) << 15))

#define MAKE_CALL_SIGNATURE_6(retType, param0Type, param1Type, param2Type, param3Type, param4Type, param5Type) \
	(	(CallSignature)(((retType) + 1))				\
	|	((CallSignature)(((param0Type) + 1)) << 3)		\
	|	((CallSignature)(((param1Type) + 1)) << 6)		\
	|	((CallSignature)(((param2Type) + 1)) << 9)		\
	|	((CallSignature)(((param3Type) + 1)) << 12)		\
	|	((CallSignature)(((param4Type) + 1)) << 15)	\
	|	((CallSignature)(((param5Type) + 1)) << 18))

#define MAKE_CALL_SIGNATURE_7(retType, param0Type, param1Type, param2Type, param3Type, param4Type, param5Type, param6Type) \
	(	(CallSignature)(((retType) + 1))				\
	|	((CallSignature)(((param0Type) + 1)) << 3)		\
	|	((CallSignature)(((param1Type) + 1)) << 6)		\
	|	((CallSignature)(((param2Type) + 1)) << 9)		\
	|	((CallSignature)(((param3Type) + 1)) << 12)		\
	|	((CallSignature)(((param4Type) + 1)) << 15)		\
	|	((CallSignature)(((param5Type) + 1)) << 18)		\
	|	((CallSignature)(((param6Type) + 1)) << 21))

#define MAKE_CALL_SIGNATURE_8(retType, param0Type, param1Type, param2Type, param3Type, param4Type, param5Type, param6Type, param7Type) \
	(	(CallSignature)(((retType) + 1))				\
	|	((CallSignature)(((param0Type) + 1)) << 3)		\
	|	((CallSignature)(((param1Type) + 1)) << 6)		\
	|	((CallSignature)(((param2Type) + 1)) << 9)		\
	|	((CallSignature)(((param3Type) + 1)) << 12)		\
	|	((CallSignature)(((param4Type) + 1)) << 15)		\
	|	((CallSignature)(((param5Type) + 1)) << 18)		\
	|	((CallSignature)(((param6Type) + 1)) << 21)		\
	|	((CallSignature)(((param7Type) + 1)) << 24))	


namespace nanojit
{
namespace interpreter
{


typedef uint64_t CallSignature;


template<typename T>
inline void doExternalCall0(IntepreterContext* a_pContext, uintptr_t callAddress, unsigned int resultReg) {

	NanoUnusedVariable(a_pContext);

	union CallbackConverter {
		uintptr_t	callAddress;
		T			(*function)();
	};

	CallbackConverter oConverter;
	oConverter.callAddress = callAddress;
	T res = oConverter.function();
	a_pContext->set<T>(resultReg, res);
}

template<typename T, typename T0>
inline void doExternalCall1(IntepreterContext* a_pContext, uintptr_t callAddress, unsigned int resultReg) {

	union CallbackConverter {
		uintptr_t	callAddress;
		T			(*function)(T0);
	};

	T0 p0 = a_pContext->getStack<T0>(0);


	CallbackConverter oConverter;
	oConverter.callAddress = callAddress;
	T res = oConverter.function(p0);
	a_pContext->set<T>(resultReg, res);
}

template<typename T, typename T0, typename T1>
inline void doExternalCall2(IntepreterContext* a_pContext, uintptr_t callAddress, unsigned int resultReg) {

	union CallbackConverter {
		uintptr_t	callAddress;
		T			(*function)(T0, T1);
	};

	T0 p0 = a_pContext->getStack<T0>(0);
	T1 p1 = a_pContext->getStack<T1>(1);

	CallbackConverter oConverter;
	oConverter.callAddress = callAddress;
	T res =  oConverter.function(p0, p1);
	a_pContext->set<T>(resultReg, res);
}

template<typename T, typename T0, typename T1, typename T2>
inline void doExternalCall3(IntepreterContext* a_pContext, uintptr_t callAddress, unsigned int resultReg) {

	union CallbackConverter {
		uintptr_t	callAddress;
		T			(*function)(T0, T1, T2);
	};

	T0 p0 = a_pContext->getStack<T0>(0);
	T1 p1 = a_pContext->getStack<T1>(1);
	T2 p2 = a_pContext->getStack<T2>(2);

	CallbackConverter oConverter;
	oConverter.callAddress = callAddress;
	T res = oConverter.function(p0, p1, p2);
	a_pContext->set<T>(resultReg, res);
}

template<typename T, typename T0, typename T1, typename T2, typename T3>
inline void doExternalCall4(IntepreterContext* a_pContext, uintptr_t callAddress, unsigned int resultReg) {

	union CallbackConverter {
		uintptr_t	callAddress;
		T			(*function)(T0, T1, T2, T3);
	};

	T0 p0 = a_pContext->getStack<T0>(0);
	T1 p1 = a_pContext->getStack<T1>(1);
	T2 p2 = a_pContext->getStack<T2>(2);
	T3 p3 = a_pContext->getStack<T3>(3);

	CallbackConverter oConverter;
	oConverter.callAddress = callAddress;
	T res = oConverter.function(p0, p1, p2, p3);
	a_pContext->set<T>(resultReg, res);
}

template<typename T, typename T0, typename T1, typename T2, typename T3, typename T4>
inline void doExternalCall5(IntepreterContext* a_pContext, uintptr_t callAddress, unsigned int resultReg) {

	union CallbackConverter {
		uintptr_t	callAddress;
		T			(*function)(T0, T1, T2, T3, T4);
	};

	T0 p0 = a_pContext->getStack<T0>(0);
	T1 p1 = a_pContext->getStack<T1>(1);
	T2 p2 = a_pContext->getStack<T2>(2);
	T3 p3 = a_pContext->getStack<T3>(3);
	T4 p4 = a_pContext->getStack<T4>(4);

	CallbackConverter oConverter;
	oConverter.callAddress = callAddress;
	T res = oConverter.function(p0, p1, p2, p3, p4);
	a_pContext->set<T>(resultReg, res);
}

template<typename T, typename T0, typename T1, typename T2, typename T3, typename T4, typename T5>
inline void doExternalCall6(IntepreterContext* a_pContext, uintptr_t callAddress, unsigned int resultReg) {

	union CallbackConverter {
		uintptr_t	callAddress;
		T			(*function)(T0, T1, T2, T3, T4, T5);
	};

	T0 p0 = a_pContext->getStack<T0>(0);
	T1 p1 = a_pContext->getStack<T1>(1);
	T2 p2 = a_pContext->getStack<T2>(2);
	T3 p3 = a_pContext->getStack<T3>(3);
	T4 p4 = a_pContext->getStack<T4>(4);
	T5 p5 = a_pContext->getStack<T5>(5);


	CallbackConverter oConverter;
	oConverter.callAddress = callAddress;
	T res = oConverter.function(p0, p1, p2, p3, p4, p5);
	a_pContext->set<T>(resultReg, res);
}

template<typename T, typename T0, typename T1, typename T2, typename T3, typename T4, typename T5, typename T6>
inline void doExternalCall7(IntepreterContext* a_pContext, uintptr_t callAddress, unsigned int resultReg) {

	union CallbackConverter {
		uintptr_t	callAddress;
		T			(*function)(T0, T1, T2, T3, T4, T5, T6);
	};

	T0 p0 = a_pContext->getStack<T0>(0);
	T1 p1 = a_pContext->getStack<T1>(1);
	T2 p2 = a_pContext->getStack<T2>(2);
	T3 p3 = a_pContext->getStack<T3>(3);
	T4 p4 = a_pContext->getStack<T4>(4);
	T5 p5 = a_pContext->getStack<T5>(5);
	T6 p6 = a_pContext->getStack<T6>(6);


	CallbackConverter oConverter;
	oConverter.callAddress = callAddress;
	T res = oConverter.function(p0, p1, p2, p3, p4, p5, p6);
	a_pContext->set<T>(resultReg, res);
}

template<typename T, typename T0, typename T1, typename T2, typename T3, typename T4, typename T5, typename T6, typename T7>
inline void doExternalCall8(IntepreterContext* a_pContext, uintptr_t callAddress, unsigned int resultReg) {

	union CallbackConverter {
		uintptr_t	callAddress;
		T			(*function)(T0, T1, T2, T3, T4, T5, T6, T7);
	};

	T0 p0 = a_pContext->getStack<T0>(0);
	T1 p1 = a_pContext->getStack<T1>(1);
	T2 p2 = a_pContext->getStack<T2>(2);
	T3 p3 = a_pContext->getStack<T3>(3);
	T4 p4 = a_pContext->getStack<T4>(4);
	T5 p5 = a_pContext->getStack<T5>(5);
	T6 p6 = a_pContext->getStack<T6>(6);
	T7 p7 = a_pContext->getStack<T7>(7);

	CallbackConverter oConverter;
	oConverter.callAddress = callAddress;
	T res = oConverter.function(p0, p1, p2, p3, p4, p5, p6, p7);
	a_pContext->set<T>(resultReg, res);
}

// void calls

inline void doVoidExternalCall0(IntepreterContext* a_pContext, uintptr_t callAddress) {

	NanoUnusedVariable(a_pContext);

	union CallbackConverter {
		uintptr_t	callAddress;
		void		(*function)();
	};

	CallbackConverter oConverter;
	oConverter.callAddress = callAddress;
	oConverter.function();
}

template<typename T0>
inline void doVoidExternalCall1(IntepreterContext* a_pContext, uintptr_t callAddress) {

	union CallbackConverter {
		uintptr_t	callAddress;
		void		(*function)(T0);
	};

	T0 p0 = a_pContext->getStack<T0>(0);


	CallbackConverter oConverter;
	oConverter.callAddress = callAddress;
	oConverter.function(p0);
}

template<typename T0, typename T1>
inline void doVoidExternalCall2(IntepreterContext* a_pContext, uintptr_t callAddress) {

	union CallbackConverter {
		uintptr_t	callAddress;
		void		(*function)(T0, T1);
	};

	T0 p0 = a_pContext->getStack<T0>(0);
	T1 p1 = a_pContext->getStack<T1>(1);

	CallbackConverter oConverter;
	oConverter.callAddress = callAddress;
	oConverter.function(p0, p1);
}

template<typename T0, typename T1, typename T2>
inline void doVoidExternalCall3(IntepreterContext* a_pContext, uintptr_t callAddress) {

	union CallbackConverter {
		uintptr_t	callAddress;
		void		(*function)(T0, T1, T2);
	};

	T0 p0 = a_pContext->getStack<T0>(0);
	T1 p1 = a_pContext->getStack<T1>(1);
	T2 p2 = a_pContext->getStack<T2>(2);

	CallbackConverter oConverter;
	oConverter.callAddress = callAddress;
	oConverter.function(p0, p1, p2);
}

template<typename T0, typename T1, typename T2, typename T3>
inline void doVoidExternalCall4(IntepreterContext* a_pContext, uintptr_t callAddress) {

	union CallbackConverter {
		uintptr_t	callAddress;
		void		(*function)(T0, T1, T2, T3);
	};

	T0 p0 = a_pContext->getStack<T0>(0);
	T1 p1 = a_pContext->getStack<T1>(1);
	T2 p2 = a_pContext->getStack<T2>(2);
	T3 p3 = a_pContext->getStack<T3>(3);

	CallbackConverter oConverter;
	oConverter.callAddress = callAddress;
	oConverter.function(p0, p1, p2, p3);
}

template<typename T0, typename T1, typename T2, typename T3, typename T4>
inline void doVoidExternalCall5(IntepreterContext* a_pContext, uintptr_t callAddress) {

	union CallbackConverter {
		uintptr_t	callAddress;
		void		(*function)(T0, T1, T2, T3, T4);
	};

	T0 p0 = a_pContext->getStack<T0>(0);
	T1 p1 = a_pContext->getStack<T1>(1);
	T2 p2 = a_pContext->getStack<T2>(2);
	T3 p3 = a_pContext->getStack<T3>(3);
	T4 p4 = a_pContext->getStack<T4>(4);

	CallbackConverter oConverter;
	oConverter.callAddress = callAddress;
	oConverter.function(p0, p1, p2, p3, p4);
}

template<typename T0, typename T1, typename T2, typename T3, typename T4, typename T5>
inline void doVoidExternalCall6(IntepreterContext* a_pContext, uintptr_t callAddress) {

	union CallbackConverter {
		uintptr_t	callAddress;
		void		(*function)(T0, T1, T2, T3, T4, T5);
	};

	T0 p0 = a_pContext->getStack<T0>(0);
	T1 p1 = a_pContext->getStack<T1>(1);
	T2 p2 = a_pContext->getStack<T2>(2);
	T3 p3 = a_pContext->getStack<T3>(3);
	T4 p4 = a_pContext->getStack<T4>(4);
	T5 p5 = a_pContext->getStack<T5>(5);


	CallbackConverter oConverter;
	oConverter.callAddress = callAddress;
	oConverter.function(p0, p1, p2, p3, p4, p5);
}

template<typename T0, typename T1, typename T2, typename T3, typename T4, typename T5, typename T6>
inline void doVoidExternalCall7(IntepreterContext* a_pContext, uintptr_t callAddress) {

	union CallbackConverter {
		uintptr_t	callAddress;
		void		(*function)(T0, T1, T2, T3, T4, T5, T6);
	};

	T0 p0 = a_pContext->getStack<T0>(0);
	T1 p1 = a_pContext->getStack<T1>(1);
	T2 p2 = a_pContext->getStack<T2>(2);
	T3 p3 = a_pContext->getStack<T3>(3);
	T4 p4 = a_pContext->getStack<T4>(4);
	T5 p5 = a_pContext->getStack<T5>(5);
	T6 p6 = a_pContext->getStack<T6>(6);


	CallbackConverter oConverter;
	oConverter.callAddress = callAddress;
	oConverter.function(p0, p1, p2, p3, p4, p5, p6);
}

template<typename T0, typename T1, typename T2, typename T3, typename T4, typename T5, typename T6, typename T7>
inline void doVoidExternalCall8(IntepreterContext* a_pContext, uintptr_t callAddress) {

	union CallbackConverter {
		uintptr_t	callAddress;
		void		(*function)(T0, T1, T2, T3, T4, T5, T6, T7);
	};

	T0 p0 = a_pContext->getStack<T0>(0);
	T1 p1 = a_pContext->getStack<T1>(1);
	T2 p2 = a_pContext->getStack<T2>(2);
	T3 p3 = a_pContext->getStack<T3>(3);
	T4 p4 = a_pContext->getStack<T4>(4);
	T5 p5 = a_pContext->getStack<T5>(5);
	T6 p6 = a_pContext->getStack<T6>(6);
	T7 p7 = a_pContext->getStack<T7>(7);

	CallbackConverter oConverter;
	oConverter.callAddress = callAddress;
	oConverter.function(p0, p1, p2, p3, p4, p5, p6, p7);
}



void doExternalCallFromSignature(IntepreterContext* a_pContext, uintptr_t callAddress, unsigned int resultReg, CallSignature signature);

} // namespace interpreter
} // namespace nanojit


